package com.web.controller.notify;

import com.alibaba.fastjson.JSONObject;
import com.hai.config.PetroConfig;
import com.hai.service.impl.OutRechargeOrderServiceImpl;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.PrintWriter;

@Controller
@RequestMapping(value = "/petroNotify")
@Api(value = "中石油业务通知")
public class PetroNotifyController {

    private static Logger log = LoggerFactory.getLogger(PetroConfig.class);



    @RequestMapping(value = "/petroCallback", method = RequestMethod.POST)
    @ApiOperation(value = "中石油回调")
    @ResponseBody
    public void rechargeCallbackByJj(@RequestBody JSONObject jsonObject,  HttpServletResponse response) {
        try {


            log.info("============回调任务Start=============");
            log.info("尖椒订单充值-回调参数: " + jsonObject);
            log.info("============回调任务End=============");


            response.setCharacterEncoding("UTF-8");
            response.setContentType("text/html;charset=utf-8");
            PrintWriter writer= response.getWriter();

            JSONObject postJson = new JSONObject();
            postJson.put("resultCode" ,"0000");
            postJson.put("errMsg" ,"");
            writer.write(postJson.toJSONString());
            writer.flush();
            writer.close();


        } catch (Exception e) {
            log.error("WechatPayController --> wechatNotify() error!", e);
        }
    }

}
