package com.hai.dao;

import com.hai.entity.ApiCoupon;
import com.hai.entity.ApiCouponExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface ApiCouponMapper extends ApiCouponMapperExt {
    @SelectProvider(type=ApiCouponSqlProvider.class, method="countByExample")
    long countByExample(ApiCouponExample example);

    @DeleteProvider(type=ApiCouponSqlProvider.class, method="deleteByExample")
    int deleteByExample(ApiCouponExample example);

    @Delete({
        "delete from api_coupon",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into api_coupon (cou_category, `type`, ",
        "goods_type, `name`, ",
        "code, `desc`, price, ",
        "cou_discount_value, cou_discount_max_value, ",
        "img, valid_type, ",
        "effective_days, valid_date, ",
        "create_time, update_time, ",
        "`status`, op_id, op_name, ",
        "ext_1, ext_2, ext_3)",
        "values (#{couCategory,jdbcType=INTEGER}, #{type,jdbcType=INTEGER}, ",
        "#{goodsType,jdbcType=VARCHAR}, #{name,jdbcType=VARCHAR}, ",
        "#{code,jdbcType=VARCHAR}, #{desc,jdbcType=VARCHAR}, #{price,jdbcType=INTEGER}, ",
        "#{couDiscountValue,jdbcType=DECIMAL}, #{couDiscountMaxValue,jdbcType=DECIMAL}, ",
        "#{img,jdbcType=VARCHAR}, #{validType,jdbcType=INTEGER}, ",
        "#{effectiveDays,jdbcType=INTEGER}, #{validDate,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(ApiCoupon record);

    @InsertProvider(type=ApiCouponSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(ApiCoupon record);

    @SelectProvider(type=ApiCouponSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="cou_category", property="couCategory", jdbcType=JdbcType.INTEGER),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_type", property="goodsType", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="code", property="code", jdbcType=JdbcType.VARCHAR),
        @Result(column="desc", property="desc", jdbcType=JdbcType.VARCHAR),
        @Result(column="price", property="price", jdbcType=JdbcType.INTEGER),
        @Result(column="cou_discount_value", property="couDiscountValue", jdbcType=JdbcType.DECIMAL),
        @Result(column="cou_discount_max_value", property="couDiscountMaxValue", jdbcType=JdbcType.DECIMAL),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="valid_type", property="validType", jdbcType=JdbcType.INTEGER),
        @Result(column="effective_days", property="effectiveDays", jdbcType=JdbcType.INTEGER),
        @Result(column="valid_date", property="validDate", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<ApiCoupon> selectByExample(ApiCouponExample example);

    @Select({
        "select",
        "id, cou_category, `type`, goods_type, `name`, code, `desc`, price, cou_discount_value, ",
        "cou_discount_max_value, img, valid_type, effective_days, valid_date, create_time, ",
        "update_time, `status`, op_id, op_name, ext_1, ext_2, ext_3",
        "from api_coupon",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="cou_category", property="couCategory", jdbcType=JdbcType.INTEGER),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_type", property="goodsType", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="code", property="code", jdbcType=JdbcType.VARCHAR),
        @Result(column="desc", property="desc", jdbcType=JdbcType.VARCHAR),
        @Result(column="price", property="price", jdbcType=JdbcType.INTEGER),
        @Result(column="cou_discount_value", property="couDiscountValue", jdbcType=JdbcType.DECIMAL),
        @Result(column="cou_discount_max_value", property="couDiscountMaxValue", jdbcType=JdbcType.DECIMAL),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="valid_type", property="validType", jdbcType=JdbcType.INTEGER),
        @Result(column="effective_days", property="effectiveDays", jdbcType=JdbcType.INTEGER),
        @Result(column="valid_date", property="validDate", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    ApiCoupon selectByPrimaryKey(Long id);

    @UpdateProvider(type=ApiCouponSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") ApiCoupon record, @Param("example") ApiCouponExample example);

    @UpdateProvider(type=ApiCouponSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") ApiCoupon record, @Param("example") ApiCouponExample example);

    @UpdateProvider(type=ApiCouponSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(ApiCoupon record);

    @Update({
        "update api_coupon",
        "set cou_category = #{couCategory,jdbcType=INTEGER},",
          "`type` = #{type,jdbcType=INTEGER},",
          "goods_type = #{goodsType,jdbcType=VARCHAR},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "code = #{code,jdbcType=VARCHAR},",
          "`desc` = #{desc,jdbcType=VARCHAR},",
          "price = #{price,jdbcType=INTEGER},",
          "cou_discount_value = #{couDiscountValue,jdbcType=DECIMAL},",
          "cou_discount_max_value = #{couDiscountMaxValue,jdbcType=DECIMAL},",
          "img = #{img,jdbcType=VARCHAR},",
          "valid_type = #{validType,jdbcType=INTEGER},",
          "effective_days = #{effectiveDays,jdbcType=INTEGER},",
          "valid_date = #{validDate,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(ApiCoupon record);
}