package com.hai.dao;

import com.hai.entity.EtcContractOrder;
import com.hai.entity.EtcContractOrderExample.Criteria;
import com.hai.entity.EtcContractOrderExample.Criterion;
import com.hai.entity.EtcContractOrderExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class EtcContractOrderSqlProvider {

    public String countByExample(EtcContractOrderExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("etc_contract_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(EtcContractOrderExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("etc_contract_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(EtcContractOrder record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("etc_contract_order");
        
        if (record.getPhone() != null) {
            sql.VALUES("phone", "#{phone,jdbcType=VARCHAR}");
        }
        
        if (record.getContractNo() != null) {
            sql.VALUES("contract_no", "#{contractNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCustId() != null) {
            sql.VALUES("cust_id", "#{custId,jdbcType=VARCHAR}");
        }
        
        if (record.getVehId() != null) {
            sql.VALUES("veh_id", "#{vehId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.VALUES("product_id", "#{productId,jdbcType=INTEGER}");
        }
        
        if (record.getCardVarietyId() != null) {
            sql.VALUES("card_variety_id", "#{cardVarietyId,jdbcType=INTEGER}");
        }
        
        if (record.getProductName() != null) {
            sql.VALUES("product_name", "#{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getCardVarietyName() != null) {
            sql.VALUES("card_variety_name", "#{cardVarietyName,jdbcType=VARCHAR}");
        }
        
        if (record.getSignImg() != null) {
            sql.VALUES("sign_img", "#{signImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getPayStatus() != null) {
            sql.VALUES("pay_status", "#{payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getSignStatus() != null) {
            sql.VALUES("sign_status", "#{signStatus,jdbcType=INTEGER}");
        }
        
        if (record.getBankSign() != null) {
            sql.VALUES("bank_sign", "#{bankSign,jdbcType=INTEGER}");
        }
        
        if (record.getWechatSign() != null) {
            sql.VALUES("wechat_sign", "#{wechatSign,jdbcType=INTEGER}");
        }
        
        if (record.getNeedSignWechat() != null) {
            sql.VALUES("need_sign_wechat", "#{needSignWechat,jdbcType=INTEGER}");
        }
        
        if (record.getVehStatus() != null) {
            sql.VALUES("veh_status", "#{vehStatus,jdbcType=INTEGER}");
        }
        
        if (record.getJumpPath() != null) {
            sql.VALUES("jump_path", "#{jumpPath,jdbcType=VARCHAR}");
        }
        
        if (record.getAppid() != null) {
            sql.VALUES("appId", "#{appid,jdbcType=VARCHAR}");
        }
        
        if (record.getOpId() != null) {
            sql.VALUES("op_id", "#{opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.VALUES("op_name", "#{opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(EtcContractOrderExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("phone");
        sql.SELECT("contract_no");
        sql.SELECT("cust_id");
        sql.SELECT("veh_id");
        sql.SELECT("product_id");
        sql.SELECT("card_variety_id");
        sql.SELECT("product_name");
        sql.SELECT("card_variety_name");
        sql.SELECT("sign_img");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("`status`");
        sql.SELECT("pay_status");
        sql.SELECT("sign_status");
        sql.SELECT("bank_sign");
        sql.SELECT("wechat_sign");
        sql.SELECT("need_sign_wechat");
        sql.SELECT("veh_status");
        sql.SELECT("jump_path");
        sql.SELECT("appId");
        sql.SELECT("op_id");
        sql.SELECT("op_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("etc_contract_order");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        EtcContractOrder record = (EtcContractOrder) parameter.get("record");
        EtcContractOrderExample example = (EtcContractOrderExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("etc_contract_order");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getPhone() != null) {
            sql.SET("phone = #{record.phone,jdbcType=VARCHAR}");
        }
        
        if (record.getContractNo() != null) {
            sql.SET("contract_no = #{record.contractNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCustId() != null) {
            sql.SET("cust_id = #{record.custId,jdbcType=VARCHAR}");
        }
        
        if (record.getVehId() != null) {
            sql.SET("veh_id = #{record.vehId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{record.productId,jdbcType=INTEGER}");
        }
        
        if (record.getCardVarietyId() != null) {
            sql.SET("card_variety_id = #{record.cardVarietyId,jdbcType=INTEGER}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        }
        
        if (record.getCardVarietyName() != null) {
            sql.SET("card_variety_name = #{record.cardVarietyName,jdbcType=VARCHAR}");
        }
        
        if (record.getSignImg() != null) {
            sql.SET("sign_img = #{record.signImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getPayStatus() != null) {
            sql.SET("pay_status = #{record.payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getSignStatus() != null) {
            sql.SET("sign_status = #{record.signStatus,jdbcType=INTEGER}");
        }
        
        if (record.getBankSign() != null) {
            sql.SET("bank_sign = #{record.bankSign,jdbcType=INTEGER}");
        }
        
        if (record.getWechatSign() != null) {
            sql.SET("wechat_sign = #{record.wechatSign,jdbcType=INTEGER}");
        }
        
        if (record.getNeedSignWechat() != null) {
            sql.SET("need_sign_wechat = #{record.needSignWechat,jdbcType=INTEGER}");
        }
        
        if (record.getVehStatus() != null) {
            sql.SET("veh_status = #{record.vehStatus,jdbcType=INTEGER}");
        }
        
        if (record.getJumpPath() != null) {
            sql.SET("jump_path = #{record.jumpPath,jdbcType=VARCHAR}");
        }
        
        if (record.getAppid() != null) {
            sql.SET("appId = #{record.appid,jdbcType=VARCHAR}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.SET("op_name = #{record.opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("etc_contract_order");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("phone = #{record.phone,jdbcType=VARCHAR}");
        sql.SET("contract_no = #{record.contractNo,jdbcType=VARCHAR}");
        sql.SET("cust_id = #{record.custId,jdbcType=VARCHAR}");
        sql.SET("veh_id = #{record.vehId,jdbcType=VARCHAR}");
        sql.SET("product_id = #{record.productId,jdbcType=INTEGER}");
        sql.SET("card_variety_id = #{record.cardVarietyId,jdbcType=INTEGER}");
        sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        sql.SET("card_variety_name = #{record.cardVarietyName,jdbcType=VARCHAR}");
        sql.SET("sign_img = #{record.signImg,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("pay_status = #{record.payStatus,jdbcType=INTEGER}");
        sql.SET("sign_status = #{record.signStatus,jdbcType=INTEGER}");
        sql.SET("bank_sign = #{record.bankSign,jdbcType=INTEGER}");
        sql.SET("wechat_sign = #{record.wechatSign,jdbcType=INTEGER}");
        sql.SET("need_sign_wechat = #{record.needSignWechat,jdbcType=INTEGER}");
        sql.SET("veh_status = #{record.vehStatus,jdbcType=INTEGER}");
        sql.SET("jump_path = #{record.jumpPath,jdbcType=VARCHAR}");
        sql.SET("appId = #{record.appid,jdbcType=VARCHAR}");
        sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        sql.SET("op_name = #{record.opName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        EtcContractOrderExample example = (EtcContractOrderExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(EtcContractOrder record) {
        SQL sql = new SQL();
        sql.UPDATE("etc_contract_order");
        
        if (record.getPhone() != null) {
            sql.SET("phone = #{phone,jdbcType=VARCHAR}");
        }
        
        if (record.getContractNo() != null) {
            sql.SET("contract_no = #{contractNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCustId() != null) {
            sql.SET("cust_id = #{custId,jdbcType=VARCHAR}");
        }
        
        if (record.getVehId() != null) {
            sql.SET("veh_id = #{vehId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{productId,jdbcType=INTEGER}");
        }
        
        if (record.getCardVarietyId() != null) {
            sql.SET("card_variety_id = #{cardVarietyId,jdbcType=INTEGER}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getCardVarietyName() != null) {
            sql.SET("card_variety_name = #{cardVarietyName,jdbcType=VARCHAR}");
        }
        
        if (record.getSignImg() != null) {
            sql.SET("sign_img = #{signImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getPayStatus() != null) {
            sql.SET("pay_status = #{payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getSignStatus() != null) {
            sql.SET("sign_status = #{signStatus,jdbcType=INTEGER}");
        }
        
        if (record.getBankSign() != null) {
            sql.SET("bank_sign = #{bankSign,jdbcType=INTEGER}");
        }
        
        if (record.getWechatSign() != null) {
            sql.SET("wechat_sign = #{wechatSign,jdbcType=INTEGER}");
        }
        
        if (record.getNeedSignWechat() != null) {
            sql.SET("need_sign_wechat = #{needSignWechat,jdbcType=INTEGER}");
        }
        
        if (record.getVehStatus() != null) {
            sql.SET("veh_status = #{vehStatus,jdbcType=INTEGER}");
        }
        
        if (record.getJumpPath() != null) {
            sql.SET("jump_path = #{jumpPath,jdbcType=VARCHAR}");
        }
        
        if (record.getAppid() != null) {
            sql.SET("appId = #{appid,jdbcType=VARCHAR}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.SET("op_name = #{opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, EtcContractOrderExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}