package com.hai.dao;

import com.hai.entity.HighCouponAgentCode;
import com.hai.entity.HighDiscountPackageActual;
import com.hai.entity.HighDiscountPackageRecord;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.type.JdbcType;

import java.util.List;

/**
 * mapper扩展类
 */
public interface HighDiscountPackageActualMapperExt {
    @Select(
            " SELECT *" +
                    " FROM high_discount_package_actual" +
                    " WHERE" +
                    " status = 3 " +
                    " AND allocation_time >= DATE_SUB(CURRENT_TIMESTAMP(), INTERVAL #{day}  DAY) " +
                    " AND user_id = #{userId} " +
                    " AND discount_package_id = #{discountPackageId}; "
    )
    List<HighDiscountPackageActual> receivePackageLimit(@Param("userId") Integer userId, @Param("discountPackageId") Integer discountPackageId, @Param("day") Integer day);
}