package com.hai.etc;

import com.hai.entity.BlxCarInfo;
import com.hai.entity.EtcCarMsg;
import com.hai.entity.EtcContractOrder;
import com.hai.entity.EtcCustMsg;

import java.util.List;
import java.util.Map;

/**
 * @serviceName .java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // etc业务
 * @createTime 15:15 2024/3/22
 **/
public interface EtcCarMsgService {

    /**
     * @Author Sum1Dream
     * @Name insertCar
     * @Description // 新增车辆信息
     * @Date 11:29 2023/9/5
     * @Param carInfo
     * @return void
     */
    void insertEtcCar(EtcCarMsg etcCarMsg) throws Exception;

    void addEtcCar(EtcCarMsg etcCarMsg) throws Exception;

    void deleteEtcCar(Long id) throws Exception;

    void updateEtcCar(EtcCarMsg etcCarMsg);

    /**
     * @Author Sum1Dream
     * @Name getCarInfoList
     * @Description // 查询车辆信息列表
     * @Date 11:30 2023/9/5
     * @Param map
     * @return java.util.List<com.hai.entity.BlxCarInfo>
     */
    List<EtcCarMsg> getEtcCarList(Map<String , Object> map);

    /**
     * @Author Sum1Dream
     * @Name findCarInfoByMap
     * @Description //TODO
     * @Date 14:14 2023/9/5
     * @Param map
     * @return com.hai.entity.BlxCarInfo
     */
    EtcCarMsg findEtcCarByMap(Map<String , Object> map);

    /**
     * @Author Sum1Dream
     * @Name findCarInfoById
     * @Description // 根据ID查询详情
     * @Date 15:13 2023/9/5
     * @Param id
     * @return com.hai.entity.BlxCarInfo
     */
    EtcCarMsg findEtcCarById(Long id);

    /**
    * @Author Sum1Dream
    * @Name insertContractOrder
    * @Description // 新增
    * @Date 10:30 2024/4/1
    * @Param etcContractOrder
     * @return com.hai.entity.EtcContractOrder
    */
    void insertContractOrder(EtcContractOrder etcContractOrder);

    /**
    * @Author Sum1Dream
    * @Name updateContractOrder
    * @Description // 修改
    * @Date 10:33 2024/4/1
    * @Param etcContractOrder
     * @return com.hai.entity.EtcContractOrder
    */
    void updateContractOrder(EtcContractOrder etcContractOrder);

    /**
    * @Author Sum1Dream
    * @Name getEtcContractOrderList
    * @Description //TODO
    * @Date 11:02 2024/4/1
    * @Param map  
     * @return java.util.List<com.hai.entity.EtcCarMsg>
    */
    List<EtcContractOrder> getEtcContractOrderList(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @Name findContractOrderById
    * @Description // 查询
    * @Date 11:02 2024/4/1
    * @Param id
     * @return com.hai.entity.EtcCarMsg
    */
    EtcContractOrder findContractOrderById(Long id);


}
