package com.hai.openApi.service;

import com.alibaba.fastjson.JSONObject;
import com.hai.entity.ApiBlxCoupon;
import com.hai.entity.ApiCoupon;

import java.util.List;
import java.util.Map;

public interface ApiCouponService {

    /**
    * @Author Sum1Dream
    * @Name insertCoupon
    * @Description // 新增卡券
    * @Date 10:05 2023/12/15 
    * @Param apiCoupon  
     * @return void
    */
    void insertCoupon(ApiCoupon apiCoupon);

    /**
    * @Author Sum1Dream
    * @Name editCoupon
    * @Description // 修改卡券
    * @Date 10:06 2023/12/15 
    * @Param apiCoupon  
     * @return void
    */
    void editCoupon(ApiCoupon apiCoupon);

    /**
    * @Author Sum1Dream
    * @Name findCoupon
    * @Description // 根据卡券编码查询券
    * @Date 10:06 2023/12/15 
    * @Param code  
     * @return com.hai.entity.ApiCoupon
    */
    ApiCoupon findCoupon(String code);
    
    /**
    * @Author Sum1Dream
    * @Name getCouponList
    * @Description // 查询券列表
    * @Date 10:06 2023/12/15 
    * @Param map  
     * @return java.util.List<com.hai.entity.ApiCoupon>
    */
    List<ApiCoupon> getCouponList(Map<String , Object> map);



}
